diff a/src/hotspot/share/classfile/systemDictionary.hpp b/src/hotspot/share/classfile/systemDictionary.hpp
--- a/src/hotspot/share/classfile/systemDictionary.hpp
+++ b/src/hotspot/share/classfile/systemDictionary.hpp
@@ -68,10 +68,11 @@
 
 class BootstrapInfo;
 class ClassFileStream;
 class ClassLoadInfo;
 class Dictionary;
+class AllFieldStream;
 class PackageEntry;
 class GCTimer;
 class EventClassLoad;
 class Symbol;
 
@@ -103,11 +104,11 @@
   }
 
   // Resolve a superclass or superinterface. Called from ClassFileParser,
   // parse_interfaces, resolve_instance_class_or_null, load_shared_class
   // "class_name" is the class whose super class or interface is being resolved.
-  static InstanceKlass* resolve_super_or_fail(Symbol* class_name,
+  static InstanceKlass* resolve_with_circularity_detection_or_fail(Symbol* class_name,
                                               Symbol* super_name,
                                               Handle class_loader,
                                               Handle protection_domain,
                                               bool is_superclass,
                                               TRAPS);
@@ -130,10 +131,11 @@
 
   static oop get_system_class_loader_impl(TRAPS);
   static oop get_platform_class_loader_impl(TRAPS);
 
  public:
+
   // Resolve either a hidden or normal class from a stream of bytes, based on ClassLoadInfo
   static InstanceKlass* resolve_from_stream(ClassFileStream* st,
                                             Symbol* class_name,
                                             Handle class_loader,
                                             const ClassLoadInfo& cl_info,
